
#include "DataList.h"

CElement::CElement()
{
	m_pItem = NULL;
	m_pNext = NULL;
	m_pHead = NULL;
}

CElement::~CElement()
{
	m_pItem = NULL;
	m_pNext = NULL;
	m_pHead = NULL;
}


CDataList::CDataList()   //Уָʼʼ
{
	m_head = NULL;
	m_tail = NULL;
	pthread_mutex_init(&m_list_mutex, NULL);
	m_index = 0;
	return;
}

CDataList::~CDataList() //ٶи
{
	ClearAll();
	return;
}

int CDataList::InsertItem(void* item) //вһ
{
	pthread_mutex_lock(&m_list_mutex);
	if (m_head == NULL)
	{
		m_head = new CElement();
		m_tail = m_head;
		m_head->m_pItem = item;
	}
	else
	{
		CElement *p = new CElement();
		p->m_pItem = item;
		p->m_pHead = m_tail;
		m_tail->m_pNext = p;
		m_tail = p;
	}
	m_index++;
	pthread_mutex_unlock(&m_list_mutex);

	return 0;
}

void* CDataList::GetItem(const int index) //ȡһ
{
	pthread_mutex_lock(&m_list_mutex);
	if (index > m_index)
	{
		pthread_mutex_unlock(&m_list_mutex);
		return NULL;
	}

	CElement *p = m_head;
	for (int i=1; i<index; i++)
	{
		p = p->m_pNext;
	}

	pthread_mutex_unlock(&m_list_mutex);
	return p->m_pItem;
}

void* CDataList::DeleteItem(const int index) 
{
	pthread_mutex_lock(&m_list_mutex);
	if (index > m_index)
	{
		pthread_mutex_unlock(&m_list_mutex);
		return NULL;
	}

	CElement *p = m_head;
	for (int i=1; i<index; i++)
	{
		p = p->m_pNext;
	}

	if ((p == m_head) && (p == m_tail))
	{
		m_head = NULL;
		m_tail = NULL;
		//cout << "==>бգ" << endl;
	}
	else if (p == m_head)
	{
		m_head = p->m_pNext;
		if (m_head != NULL)
			m_head->m_pHead = NULL;
	}
	else if (p == m_tail)
	{
		m_tail = p->m_pHead;
		if (m_tail != NULL)
			m_tail->m_pNext = NULL;
	}
	else
	{
		p->m_pHead->m_pNext = p->m_pNext;
		p->m_pNext->m_pHead = p->m_pHead;
	}

	void *pItem = NULL;
	pItem = p->m_pItem;

	p->m_pItem = NULL;
	delete p;

	m_index--;
	pthread_mutex_unlock(&m_list_mutex);

	return pItem;
}

void CDataList::ClearAll(void)
{
	//pthread_mutex_lock(&m_list_mutex);
	while (m_index > 0)
	{
		void *p = DeleteItem();
		if (p != NULL)
			delete p;
	}
	//pthread_mutex_unlock(&m_list_mutex);
/*	
	pthread_mutex_lock(&m_list_mutex);
	CElement *p = m_head;
	if (p == NULL)
	{
		m_head = NULL;
		m_tail = NULL;
		m_index = 0;
		pthread_mutex_unlock(&m_list_mutex);
		return;
	}

	while (p != NULL) 
	{
		CElement *pElem = p;
		p = p->m_pNext;
		void *pTmp = pElem->m_pItem;
		pElem->m_pItem = NULL;
		if (pTmp != NULL)
		{
			//printf("ͷָ:[0x%x]\n", pTmp);
			delete pTmp;
		}
		//printf("==>ͷŽڵָ:[0x%x]\n", pElem);
		delete pElem;
		m_index--;
	}

	m_head = NULL;
	m_tail = NULL;
	pthread_mutex_unlock(&m_list_mutex);
*/
	return;
}

void CDataList::ShowAll(void)
{
	pthread_mutex_lock(&m_list_mutex);
	CElement *p = m_head;
	if (p == NULL)
	{
		pthread_mutex_unlock(&m_list_mutex);
		return;
	}

	while (p != NULL) 
	{
		void *pTmp = (void *)p->m_pItem;
		printf("==>ڵַָ:[0x%x]\n", p);
		p = p->m_pNext;
	} 

	pthread_mutex_unlock(&m_list_mutex);

	return;
}

