
/*************************************************************
  function:	ͨЭͷṹ
  date:		2005/05/18
  created:	Liaomch
*************************************************************/
#ifndef __GSMP_HEAD_H__
#define __GSMP_HEAD_H__

#ifndef LINUX
#define LINUX
#endif

#ifdef LINUX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <string>
#include <iostream>
#include <pthread.h>
#include <fcntl.h>
#include <signal.h>
#include <fstream>
using namespace std;
#endif

#ifdef WIN32
#define socklen_t int
#endif

#define UC	unsigned char

#define MAX_SUBMIT      16   /*մڴС */

const int END_SUCCEED =	0;
const int END_FAILED = -1;

const unsigned int MAX_LOGIN_NUM = 5;

const unsigned int SERVER_MODEL_SEND = 2;
const unsigned int SERVER_MODEL_RECV = 1;
const unsigned int SERVER_MODEL_SDRV = 0;

const unsigned int CLIENT_MODEL_SEND = 1;
const unsigned int CLIENT_MODEL_RECV = 2;
const unsigned int CLIENT_MODEL_SDRV = 0;

const int MAX_RECVRESP_TIME = 100;//seconds
const int HEAD_SIZE = sizeof(unsigned int) * 2 + sizeof(unsigned short) * 2;

const unsigned int MAX_QUEUE_SIZE = 20;//󳤶

//Q=15ӣT=60룬N=3
#define		GSMP_Q	15
#define		GSMP_T	60
#define		GSMP_N	3

//ϢID
#define		GSMP_LOGIN		0x00000001	//¼
#define		GSMP_LOGIN_RESP		0x80000001	//¼Ӧ
#define		GSMP_TERMINATE		0x00000002	//ע¼
#define		GSMP_TERMINATE_RESP	0x80000002	//ע¼Ӧ
#define		GSMP_QLINK		0x00000003	//·״̬ѯϢ
#define		GSMP_QLINK_RESP		0x80000003	//·״̬ѯϢӦ
#define		GSMP_SUBMIT		0x00000004	//MT
#define		GSMP_SUBMIT_RESP	0x80000004	//MTӦ
#define		GSMP_DELIVER		0x00000005	//MOϢ
#define		GSMP_DELIVER_RESP	0x80000005	//MOϢӦ
#define		GSMP_REPORT		0x00000006	//״̬
#define		GSMP_REPORT_RESP	0x80000006	//״̬Ӧ

//붨
#define GSMP_SUCCEED			0		//޴ȷ

//1*** CPش
#define GSMP_ERR_USER_REGISTER	1001	//Ƿ¼¼¼ȡ

//2*** Ĵ
#define GSMP_ERR_MSG_NULL		2000	//ʽָвֵͲЭ涨ķΧ

//3xxx		3ʼĴΪOPش
//4xxx		4ʼĴΪWEBӿڴ
//5xxx		5ʼĴΪ
#define GSMP_ERR_UNKNOW			5000

//package head
class CGSMPHead
{
public:
	CGSMPHead();
	~CGSMPHead();

	void Replace(CGSMPHead *pHead);

public:
	unsigned int nTotalLength;
	unsigned int nCommandId;
	unsigned short nSequence;
	unsigned short nVersion;
};

//login package
class CGSMPLogin
{
public:
	CGSMPLogin();
	~CGSMPLogin();

	int OutXmlBuf(char *pBuf, int *pLen=NULL);
	int InXmlBuf(char *pBuf);
	void Replace(CGSMPLogin *pMsg);

public:
	CGSMPHead m_Head;

	string m_sUser;
	string m_sPassword;
	string m_sLoginType;
};

//submit resp
class CGSMPSubmitResp
{
public:
	CGSMPSubmitResp();
	~CGSMPSubmitResp();

	int OutXmlBuf(char *pBuf, int *pLen=NULL);
	int InXmlBuf(char *pBuf);

	void Replace(CGSMPSubmitResp *pMsg);

public:
	CGSMPHead m_Head;

	string m_sMsgid;
	string m_sResult;

	time_t m_nRecvTime;
};

//login,deliver,report resp
class CGSMPResp
{
public:
	CGSMPResp();
	~CGSMPResp();

	int OutXmlBuf(char *pBuf, int *pLen=NULL);
	int InXmlBuf(char *pBuf);

	void Replace(CGSMPResp *pMsg);

public:
	CGSMPHead m_Head;

	string m_sResult;

	time_t m_nRecvTime;
};

class CGSMPSubmit
{
public:
	CGSMPSubmit();
	~CGSMPSubmit();

	int OutXmlBuf(char *pBuf, int *pLen=NULL);
	int InXmlBuf(char *pBuf);

	void Replace(CGSMPSubmit *pMsg);

public:
	CGSMPHead m_Head;

	string m_sMsgType;//Ϣ
	string m_sMsgId;//Ϣк
	string m_sSrcGWId;//ԴCPرʶ
	string m_sDestGWId;//ĿOPرʶ
	string m_sSrcTermId;//Դ
	string m_sChargeTermId;//ƷѺ
	string m_sChargeTermType;//ƷѺͣ0-ʵֻ 1-α
	string m_sDestTermCount;//ĿֻĿǰ֧50
	string m_sDestTermId;//Ŀֻ룬֮Զŷָ
	string m_sDestTermType;//Ŀֻͣ0-ʵֻ 1-α
	string m_sServiceId;//ҵ
	string m_sFeeType;//Ʒ
	string m_sFeeCode;//ƷѴ
	string m_sGivenValue;//	ͨûΪͻ,СͨûΪⶥ,λΪ
	string m_sMTF;//MTԭ:
	string m_sMsgLevel;//ȼ
	string m_sValidTime;//Чʱ
	string m_sAtTime;//Ϣʱ͵ʱ䣬Ϊգʾ̷͸öϢ
	string m_sNeedReport;//ǷҪ״̬ 
	string m_sTPpid;//GSMЭ͡ϸǽοGSM03.40е9.2.3.9
	string m_sTPudhi;//GSMЭ͡ϸǽοGSM03.40е9.2.3.23
	string m_sMsgFmt;//Ϣıʽ
	string m_sMsgContType;//ͣ0ı1ҪBASE64
	string m_sMsgCont;//Ϣ
	string m_sLinkId;//㲥MTļȨϢ
};

class CGSMPDeliver
{
public:
	CGSMPDeliver();
	~CGSMPDeliver();

	int OutXmlBuf(char *pBuf, int *pLen=NULL);
	int InXmlBuf(char *pBuf);

	void Replace(CGSMPDeliver *pMsg);

public:
	CGSMPHead m_Head;

	string m_sMsgType;//Ϣ
	string m_sMsgId;//	
	string m_sSrcGWId;//ԴOPرʶ
	string m_sDestGWId;//ĿCPرʶ
	string m_sSrcTermId;//Դֻ
	string m_sSrcTermType;//Դֻͣ0-ʵֻ 1-α
	string m_sDestTermId;//Ŀĺ.
	string m_sServiceId;//ҵ
	string m_sMsgLevel;//	ȼ
	string m_sMsgFmt;//Ϣıʽ
	string m_sMsgContType;//ͣ0ı1ҪBASE64
	string m_sMsgCont;//	Ϣ
	string m_sLinkId;//㲥MTļȨϢ, 
};

class CGSMPReport
{
public:
	CGSMPReport();
	~CGSMPReport();

	int OutXmlBuf(char *pBuf, int *pLen=NULL);
	int InXmlBuf(char *pBuf);

	void Replace(CGSMPReport *pMsg);

public:
	CGSMPHead m_Head;

	string m_sMsgType;//Ϣ
	string m_sMsgId;//״̬汾Ϣ
	string m_sSubmitMsgId;//״̬漰SubmitϢ
	string m_sDestTermId;//Ŀֻ
	string m_sStat;//ݸֶȷSubmitϢ״̬
	string m_sSubmitTime;//ύʱ,YYMMDDHHMMYYΪĺλ00-99MM01-12DD01-31HH00-23MM00-59
	string m_sDoneTime;//ʱ, YYMMDDHHMM
};


#endif


