

/*****************************
 ** FILE: GSMPClient.h    ****
 ** Auth: Liaomch         ****
 ** Date: 2005-04-19      ****
 ** Modify:               ****
 *****************************/

/*
 *	GSMPClient.h
 */

#ifndef __GSMP_CLIENT_H__
#define __GSMP_CLIENT_H__

#include "SockBase.h"
#include "TXTLog.h"

#include "GSMP.h"
#include "GSMPPkg.h"
#include "Config.h"
#include <vector>

class CGSMPClient : CSockBase
{
public:
	CGSMPClient();
	~CGSMPClient();
	
	bool GSMPInit(int nModel, char *pConfFile = NULL);
	
	int GSMPRecvDeliver(CGSMPDeliver *pDeliver, char *pMsgid, int nTimeOut);
	int GSMPRecvReport(CGSMPReport *pReport, char *pMsgid, int nTimeOut);
	int GSMPSendSubmit(CGSMPSubmit *pSubmit, char *pMsgid);

	//int GSMPSendReport(CGSMPReport *pReport, char *pMsgid);
	//int GSMPSendDeliver(CGSMPDeliver *pDeliver, char *pMsgid);
	int GSMPRecvSubmit(CGSMPSubmit *pSubmit, char *pMsgid, int nTimeOut);

	void GSMPFinal(void);

public:
	int DoConnect(int nModel);
	int ConnectToSMC(int nModel);
	bool HadTimeOut(time_t tBase, int nTimeOut);

	static void *RecvThread(CGSMPClient *pClient);

	bool GetConfig(char *pFile = NULL);
	int DisConnect(void);
	void ClearAllQueue(void);

public:
	pthread_mutex_t m_VecDel_mutex;
	pthread_mutex_t m_VecDelResp_mutex;
	pthread_mutex_t m_VecSub_mutex;
	pthread_mutex_t m_VecSubResp_mutex;
	pthread_mutex_t m_VecRpt_mutex;
	pthread_mutex_t m_VecRptResp_mutex;

	vector<CGSMPDeliver *> m_pDeliver;//صmo deliver
	vector<CGSMPReport *> m_pReport; //صmo Report
	vector<CGSMPSubmit *> m_pSubmit;//յMT SUBMIT

	vector<CGSMPResp *> m_pRptResp; //recv report resp
	vector<CGSMPResp *> m_pDelResp; //recv deliver resp
	vector<CGSMPSubmitResp *> m_pSubResp; //յMT RESP

	pthread_mutex_t m_connect_mutex;
	pthread_mutex_t m_send_mutex;
	pthread_mutex_t m_recv_mutex;

	CTXTLog *m_pLog;
	CSXmlDoc *m_pXmlConf;
	CGSMPPkg *m_pkg;

	time_t m_tLastActive;//һηʱ
	int m_nSubmitTimes; //طSUBMITĴ
	bool m_bInitConf;
	bool m_bTermitnate;
	


public:
	int m_nSock;
	unsigned int m_nModel;

public:
	string m_strIP;
	int  m_nPort;
	string m_strUser;
	string m_strPass;
};

#endif//


