// SockBase.h: interface for the CSockBase class.
//
//////////////////////////////////////////////////////////////////////

#if !defined __SOCKET_BASE_H__
#define __SOCKET_BASE_H__

#include "GSMP.h"

class CSockBase  
{
public:
	CSockBase();
	virtual ~CSockBase();

public:
	bool SendToDest(int nSockfd, const char *pBuf, int nLen); 
	int RecvFromDest(int nSockfd, char *pBuf, int *pLen, int nTimeout);

	int tcp_recv(int nSockfd, char *pBuf, int nLen, int nTimeOut); 
	int ConnectTimeOut(int sockfd, const struct sockaddr *saptr, socklen_t socklen, int secs);

	//********************************************************************
	//	TcpConnect
	//		Build up a TCP connection to host at port.  This is used at
	//		client part, returns the socket fd on success, or -1 on error
	//********************************************************************
	int TcpConnect(char* host, int port);

	//********************************************************************
	//  TcpConnecto:
	//      Time out version.
	//      Build up a TCP connection to host at port.  This is used at
	//      client part, returns the socket fd on success, or -1 on error
	//********************************************************************
	int TcpConnectTimeOut(char* host, int port,int secs);

	int CreateServer(int Iport);
	int GetAccept( int nSockfd );

private:
	void turn_byte_order( unsigned char *ps_dest, unsigned char *ps_src, short t_len);
	int m_iAcceptNum;

#ifdef LINUX
	pthread_mutex_t m_socketbase_send_mutex;
	pthread_mutex_t m_socketbase_recv_mutex;
#endif

#ifdef WIN32
	CMutex m_socketbase_send_mutex;
	CMutex m_socketbase_recv_mutex;
#endif

};

#endif // !defined(AFX_SOCKBASE_H__01516D52_3A8A_45B7_8827_623EBDBA1E1D__INCLUDED_)
