
#include "TXTLog.h"

CTXTLog::CTXTLog()
{
		m_bLogNameChange = true;
		m_nLogLevel = 0;
        m_nHan = -1;
        memset(m_cFile, 0, sizeof(m_cFile));
		memset(m_cPreFile, 0, sizeof(m_cPreFile));
        strcpy(m_cPreFile, "system");
		GetDateBuf((char *)m_cFile, 1);

        if ((m_nHan = open(m_cFile, O_WRONLY)) == -1)
        {
                m_nHan = open(m_cFile, O_WRONLY|O_CREAT|O_TRUNC, 0666);
        }
#ifdef LINUX
		pthread_mutex_init(&m_log_mutex , NULL);
#endif
		
}

CTXTLog::CTXTLog(char *pPre)
{
	m_bLogNameChange = true;
	m_nLogLevel = 0;
        m_nHan = -1;
        memset(m_cFile, 0, sizeof(m_cFile));
	memset(m_cPreFile, 0, sizeof(m_cPreFile));
	SetFilePre(pPre);

        //strcpy(m_cFile, "./gateway.log");
	GetDateBuf((char *)m_cFile, 1);

    if ((m_nHan = open(m_cFile, O_WRONLY)) == -1)
    {
            m_nHan = open(m_cFile, O_WRONLY|O_CREAT|O_TRUNC, 0666);
    }
#ifdef LINUX
	pthread_mutex_init(&m_log_mutex , NULL);
#endif
		
}

CTXTLog::CTXTLog(char *pPre, bool bChange)
{
	m_bLogNameChange = bChange;
	m_nLogLevel = 0;
        m_nHan = -1;
        memset(m_cFile, 0, sizeof(m_cFile));
	memset(m_cPreFile, 0, sizeof(m_cPreFile));
	SetFilePre(pPre);

        if (m_bLogNameChange)
		GetDateBuf((char *)m_cFile, 1);
	else
		strcpy((char *)m_cFile, (const char *)pPre);

        if ((m_nHan = open(m_cFile, O_WRONLY)) == -1)
        {
                m_nHan = open(m_cFile, O_WRONLY|O_CREAT|O_TRUNC, 0666);
        }
#ifdef LINUX
	pthread_mutex_init(&m_log_mutex , NULL);
#endif
}

CTXTLog::~CTXTLog(void)
{
        if (m_nHan != -1)
                close(m_nHan);
}

void CTXTLog::SetLogLevel(int nLevel)
{
	m_nLogLevel = nLevel;
	return;
}

void CTXTLog::AddLog(char *pLog, int nLevel )
{
	if (m_nLogLevel <= nLevel)
		add(pLog);
	else
		cout << pLog << endl;
		//printf("%s\n", pLog);

	return;
}

void CTXTLog::AddLog(string &strLog, int nLevel)
{
	if (m_nLogLevel <= nLevel)
		add((char *)strLog.c_str());
	else
		cout << strLog << endl;
		//printf("%s\n", pLog);

	return;
}

void CTXTLog::SetFilePre(char *pPre)
{
	strcpy((char *)m_cPreFile, pPre);
	return;
}

void CTXTLog::add(char *pLog)
{
	if (this->m_bLogNameChange)
	{
		char cFileName[50];
		memset(cFileName, 0, sizeof(cFileName));
		GetDateBuf((char *)cFileName, 1);
		if (strncmp((const char *)cFileName, (const char *)m_cFile, strlen(m_cFile)) != 0)
		{
			strcpy((char *)m_cFile, (char *)cFileName);
			close(m_nHan);
			m_nHan = -1;
		}
	}

	#ifdef WIN32
		m_log_mutex.Lock();
	#endif
	#ifdef LINUX
		pthread_mutex_lock(&m_log_mutex);
	#endif
        if (m_nHan < 0)
        {
                if ((m_nHan = open(m_cFile, O_RDWR)) == -1)
                {
                        if ((m_nHan = open(m_cFile, O_WRONLY|O_CREAT|O_TRUNC, 0666)) == -1)
			{
			#ifdef WIN32
				m_log_mutex.Unlock();
			#endif
			#ifdef LINUX
				pthread_mutex_unlock(&m_log_mutex);
			#endif
				return;
			}
		}
	}
	#ifdef WIN32
		m_log_mutex.Unlock();
	#endif
	#ifdef LINUX
		pthread_mutex_unlock(&m_log_mutex);
	#endif
        char cBuf[1024] = "";
        memset(cBuf, 0, sizeof(cBuf));

        time_t tt = time(NULL);
        struct tm *pTime = localtime(&tt);
        char cTime[40] = "";
        memset(cTime, 0, sizeof(cTime));
        sprintf(cTime, "[ %04d-%02d-%02d %02d:%02d:%02d ] ", 
					pTime->tm_year+1900,
       					pTime->tm_mon+1,
                                        pTime->tm_mday,
                                        pTime->tm_hour,
                                        pTime->tm_min,
                                        pTime->tm_sec);
        strcat(cBuf, cTime);
        strcat(cBuf, pLog);
	memset(cTime, 0, sizeof(cTime));
	sprintf(cTime, "%c", '\n');
	strcat(cBuf, cTime);

        int nLen = strlen(cBuf);
        int nWrLen = 0;
#ifdef LINUX
	pthread_mutex_lock(&m_log_mutex);
#endif
#ifdef WIN32
	m_log_mutex.Lock();
#endif
        while (nLen > 0)
        {
                lseek(m_nHan, 0, SEEK_END);
                nLen -= nWrLen;
                nWrLen = write(m_nHan, cBuf, nLen);
        }
#ifdef LINUX
	pthread_mutex_unlock(&m_log_mutex);
#endif
#ifdef WIN32
	m_log_mutex.Unlock();
#endif
}

void CTXTLog::GetDateBuf(char *pDate, int nType)
{
    time_t tt = time(NULL);
    struct tm *pTime = localtime(&tt);
    char cTime[40] = "";
    memset(cTime, 0, sizeof(cTime));

	if (nType == 0)
	{
		sprintf(cTime, "%c[ %04d-%02d-%02d %02d:%02d:%02d ] ", '\n',
						pTime->tm_year+1900,
                        pTime->tm_mon+1,
                        pTime->tm_mday,
                        pTime->tm_hour,
                        pTime->tm_min,
                        pTime->tm_sec);
	}
	else
	{
		sprintf(cTime, "%s_%04d%02d%02d.log", m_cPreFile,
						pTime->tm_year+1900,
                        pTime->tm_mon+1,
                        pTime->tm_mday);
	}

	strcpy(pDate, (const char *)cTime);
	return;
}





