// XmlConfig.h: interface for the CXmlConfig class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLCONFIG_H__20FE8CA7_8B78_40D5_8BB0_D71D079CD6E8__INCLUDED_)
#define AFX_XMLCONFIG_H__20FE8CA7_8B78_40D5_8BB0_D71D079CD6E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "tinyxml.h"

#ifdef TIXML_USE_STL
        using namespace std;
        #include <iostream>
        #include <sstream>
        #include <strstream>
#else
        #include <stdio.h>
#endif

class CXmlConfig  
{
public:
	CXmlConfig();
	CXmlConfig(const char* chsFileName);
	virtual ~CXmlConfig();

private:
	TiXmlDocument	m_tXmlDoc;
	TiXmlElement*	m_pRootElem;

public:

	bool LoadFile(const char* chsFileName);
	unsigned int GetChildCount(TiXmlElement* pParent, const char* chsName=NULL);
	TiXmlElement* GetRootElem(){return m_pRootElem;}
	TiXmlElement* GetChildElem(TiXmlElement* pParent, unsigned int nIndex=0, const char* chsName=NULL);
	bool GetAttrValueByName(TiXmlElement* pElem, const char* chsName, char* chsValue);
	bool GetElemValueByName(TiXmlElement* pElem, const char* chsName, char* chsValue);

	bool Parse(const char * str);
	void GetXmlChar(char *value);
	const char * GetXmlChar();
	void Print(void);
};

#endif // !defined(AFX_XMLCONFIG_H__20FE8CA7_8B78_40D5_8BB0_D71D079CD6E8__INCLUDED_)
